<?php
/*
Plugin Name: FLV Embed
Plugin URI: http://www.channel-ai.com/blog/plugins/flv-embed/
Description: Standards compliant FLV embedding in your posts using Javascript and FLV Player by Jeroen Wijering
Version: 0.1
Author: Yaosan Yeo
Author URI: http://www.channel-ai.com/blog/
*/

/*  Copyright 2007  Yaosan Yeo  (email : eyn@channel-ai.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// configurable variables (global variables)

	$flv_autostart = 0;				// Set this to 1 if you want the flv player to automatically start playing (not recommended)
	$flv_showdigits = 0;			// Set this to 1 to show the digits for % loaded, elapsed and remaining time in the flvplayer
	$flv_showfsbutton = 1;			// Set this to 1 to show the fullscreen button.
	$flv_useposter = 1;				// Set this to 1 if you want to display poster frame i.e. preview image
	$flv_imagetype = "jpg";			// Preview image extension, can be "jpg", "png" or "gif"
	$flv_background = "FFFFFF";		// Background color of your page
	$flv_backcolor = "FFFFFF";		// Background color of the flvplayer
	$flv_frontcolor = "000000";		// Texts / buttons color of the flvplayer
	$flv_lightcolor = "000000";		// Rollover/ active color of the flvplayer

// end of configurable variables

	$flv_counter = 0;					// Count how many players are inserted

function flv_parse($content)
{
	$content = preg_replace_callback( "/\[flv:(([^]]+))]/i", "flv_embed", $content );
	return $content;
}

function flv_embed($matches)
{
	global $post, $flv_autostart, $flv_useposter, $flv_imagetype, $flv_background, $flv_backcolor, $flv_frontcolor, $flv_lightcolor, $flv_showdigits, $flv_showfsbutton, $flv_counter;

	$fs = get_settings('siteurl') . '/wp-content/plugins/flv-embed/fullscreen.php';
	$player = get_settings('siteurl') . '/wp-content/plugins/flv-embed/flvplayer.swf';
	$return = get_permalink($post->ID);
	
	// return custom message for RSS feeds
	if (is_feed()) {
		return "[See post to watch Flash video]";
	}

	$input = explode(" ", $matches[2]);

	list($movie, $width, $height) = $input;
	$height += 20;		// Extra 20px for controller bar
	$image = str_replace(".flv", ".", $movie);
	
	$showdigits = ($flv_showdigits) ? "&showdigits=true" : "";
	$autostart = ($flv_autostart) ? "&autostart=true" : "";
	$fullscreen = ($flv_showfsbutton) ? "&showfsbutton=true&fullscreenpage=$fs&fsreturnpage=$return" : "";
	
	$image = ($flv_useposter) ? "&image=$image$flv_imagetype" : "";
	
	$backcolor = ($flv_backcolor == "FFFFFF") ? "" : "&backcolor=0x$flv_backcolor";
	$frontcolor = ($flv_frontcolor == "000000") ? "" : "&frontcolor=0x$flv_frontcolor";
	$lightcolor = ($flv_lightcolor == "000000") ? "" : "&lightcolor=0x$flv_frontcolor";
	
	$flv_counter++;

	// start outputting javascript
	ob_start();
	print <<< UFO
</p><div id="player{$flv_counter}" style="display:none"><a href="http://www.macromedia.com/go/getflashplayer">Get the Flash Player</a> to see this player.</div>
<noscript><p>[Javascript required to view Flash movie, please turn it on and refresh this page]</p></noscript>

<script type="text/javascript">
// <![CDATA[
var FO = { movie:"{$player}",width:"{$width}",height:"{$height}",majorversion:"7",build:"0",bgcolor:"#{$flv_background}",flashvars:"file={$movie}{$image}{$showdigits}{$fullscreen}{$autostart}{$backcolor}{$frontcolor}{$lightcolor}" };
UFO.create(FO,"player{$flv_counter}");
document.getElementById('player{$flv_counter}').style.display = "";
// ]]>
</script><p>
UFO;
	$output = ob_get_contents();
	ob_end_clean();

	return $output;
}

add_filter('the_content', 'flv_parse');
add_filter('the_excerpt', 'flv_parse');

// Import external javascript in Wordpress header
function flv_head() {
	$path = get_settings('siteurl') . '/wp-content/plugins/flv-embed/ufo.js';
	echo '<script type="text/javascript" src="' . $path . '"></script>';
	echo "\n";
}

add_action('wp_head', 'flv_head');
?>
